9ae3a8
From 50513a8391e05285c27241e1cf781ff1370972bf Mon Sep 17 00:00:00 2001
9ae3a8
From: Max Reitz <mreitz@redhat.com>
9ae3a8
Date: Fri, 1 Nov 2013 14:23:17 +0100
9ae3a8
Subject: [PATCH 29/81] qemu-iotests: Test for loading VM state from qcow2
9ae3a8
9ae3a8
RH-Author: Max Reitz <mreitz@redhat.com>
9ae3a8
Message-id: <1383315797-30938-4-git-send-email-mreitz@redhat.com>
9ae3a8
Patchwork-id: 55218
9ae3a8
O-Subject: [RHEL-7.0 qemu-kvm PATCH 3/3] qemu-iotests: Test for loading VM state from qcow2
9ae3a8
Bugzilla: 1025740
9ae3a8
RH-Acked-by: Kevin Wolf <kwolf@redhat.com>
9ae3a8
RH-Acked-by: Stefan Hajnoczi <stefanha@redhat.com>
9ae3a8
RH-Acked-by: Alex Williamson <alex.williamson@redhat.com>
9ae3a8
9ae3a8
BZ: 1025740
9ae3a8
9ae3a8
Add a test for saving a VM state from a qcow2 image and loading it back
9ae3a8
(with having restarted qemu in between); this should work without any
9ae3a8
problems.
9ae3a8
9ae3a8
Signed-off-by: Max Reitz <mreitz@redhat.com>
9ae3a8
Signed-off-by: Kevin Wolf <kwolf@redhat.com>
9ae3a8
(cherry picked from commit ab6f2bbb2871db8a7ed2457328e864cdf2e2fc82)
9ae3a8
9ae3a8
Signed-off-by: Max Reitz <mreitz@redhat.com>
9ae3a8
9ae3a8
Conflicts:
9ae3a8
	tests/qemu-iotests/group
9ae3a8
9ae3a8
Conflicts because upstream contains more test in the group file.
9ae3a8
---
9ae3a8
 tests/qemu-iotests/068     | 65 ++++++++++++++++++++++++++++++++++++++++++++++
9ae3a8
 tests/qemu-iotests/068.out | 11 ++++++++
9ae3a8
 tests/qemu-iotests/group   |  1 +
9ae3a8
 3 files changed, 77 insertions(+)
9ae3a8
 create mode 100755 tests/qemu-iotests/068
9ae3a8
 create mode 100644 tests/qemu-iotests/068.out
9ae3a8
9ae3a8
Signed-off-by: Miroslav Rezanina <mrezanin@redhat.com>
9ae3a8
---
9ae3a8
 tests/qemu-iotests/068     |   65 ++++++++++++++++++++++++++++++++++++++++++++
9ae3a8
 tests/qemu-iotests/068.out |   11 +++++++
9ae3a8
 tests/qemu-iotests/group   |    1 +
9ae3a8
 3 files changed, 77 insertions(+), 0 deletions(-)
9ae3a8
 create mode 100755 tests/qemu-iotests/068
9ae3a8
 create mode 100644 tests/qemu-iotests/068.out
9ae3a8
9ae3a8
diff --git a/tests/qemu-iotests/068 b/tests/qemu-iotests/068
9ae3a8
new file mode 100755
9ae3a8
index 0000000..b72e555
9ae3a8
--- /dev/null
9ae3a8
+++ b/tests/qemu-iotests/068
9ae3a8
@@ -0,0 +1,65 @@
9ae3a8
+#!/bin/bash
9ae3a8
+#
9ae3a8
+# Test case for loading a saved VM state from a qcow2 image
9ae3a8
+#
9ae3a8
+# Copyright (C) 2013 Red Hat, Inc.
9ae3a8
+#
9ae3a8
+# This program is free software; you can redistribute it and/or modify
9ae3a8
+# it under the terms of the GNU General Public License as published by
9ae3a8
+# the Free Software Foundation; either version 2 of the License, or
9ae3a8
+# (at your option) any later version.
9ae3a8
+#
9ae3a8
+# This program is distributed in the hope that it will be useful,
9ae3a8
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
9ae3a8
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
9ae3a8
+# GNU General Public License for more details.
9ae3a8
+#
9ae3a8
+# You should have received a copy of the GNU General Public License
9ae3a8
+# along with this program.  If not, see <http://www.gnu.org/licenses/>.
9ae3a8
+#
9ae3a8
+
9ae3a8
+# creator
9ae3a8
+owner=mreitz@redhat.com
9ae3a8
+
9ae3a8
+seq="$(basename $0)"
9ae3a8
+echo "QA output created by $seq"
9ae3a8
+
9ae3a8
+here="$PWD"
9ae3a8
+tmp=/tmp/$$
9ae3a8
+status=1	# failure is the default!
9ae3a8
+
9ae3a8
+_cleanup()
9ae3a8
+{
9ae3a8
+	_cleanup_test_img
9ae3a8
+}
9ae3a8
+trap "_cleanup; exit \$status" 0 1 2 3 15
9ae3a8
+
9ae3a8
+# get standard environment, filters and checks
9ae3a8
+. ./common.rc
9ae3a8
+. ./common.filter
9ae3a8
+
9ae3a8
+# This tests qocw2-specific low-level functionality
9ae3a8
+_supported_fmt qcow2
9ae3a8
+_supported_proto generic
9ae3a8
+_supported_os Linux
9ae3a8
+
9ae3a8
+IMGOPTS="compat=1.1"
9ae3a8
+IMG_SIZE=128K
9ae3a8
+
9ae3a8
+echo
9ae3a8
+echo "=== Saving and reloading a VM state to/from a qcow2 image ==="
9ae3a8
+echo
9ae3a8
+_make_test_img $IMG_SIZE
9ae3a8
+# Give qemu some time to boot before saving the VM state
9ae3a8
+bash -c 'sleep 1; echo -e "savevm 0\nquit"' |\
9ae3a8
+    $QEMU -nographic -monitor stdio -serial none -hda "$TEST_IMG" |\
9ae3a8
+    _filter_qemu
9ae3a8
+# Now try to continue from that VM state (this should just work)
9ae3a8
+echo quit |\
9ae3a8
+    $QEMU -nographic -monitor stdio -serial none -hda "$TEST_IMG" -loadvm 0 |\
9ae3a8
+    _filter_qemu
9ae3a8
+
9ae3a8
+# success, all done
9ae3a8
+echo "*** done"
9ae3a8
+rm -f $seq.full
9ae3a8
+status=0
9ae3a8
diff --git a/tests/qemu-iotests/068.out b/tests/qemu-iotests/068.out
9ae3a8
new file mode 100644
9ae3a8
index 0000000..abe35a9
9ae3a8
--- /dev/null
9ae3a8
+++ b/tests/qemu-iotests/068.out
9ae3a8
@@ -0,0 +1,11 @@
9ae3a8
+QA output created by 068
9ae3a8
+
9ae3a8
+=== Saving and reloading a VM state to/from a qcow2 image ===
9ae3a8
+
9ae3a8
+Formatting 'TEST_DIR/t.IMGFMT', fmt=IMGFMT size=131072 
9ae3a8
+QEMU X.Y.Z monitor - type 'help' for more information
9ae3a8
+(qemu) s?[K?[Dsa?[K?[D?[Dsav?[K?[D?[D?[Dsave?[K?[D?[D?[D?[Dsavev?[K?[D?[D?[D?[D?[Dsavevm?[K?[D?[D?[D?[D?[D?[Dsavevm ?[K?[D?[D?[D?[D?[D?[D?[Dsavevm 0?[K
9ae3a8
+(qemu) q?[K?[Dqu?[K?[D?[Dqui?[K?[D?[D?[Dquit?[K
9ae3a8
+QEMU X.Y.Z monitor - type 'help' for more information
9ae3a8
+(qemu) q?[K?[Dqu?[K?[D?[Dqui?[K?[D?[D?[Dquit?[K
9ae3a8
+*** done
9ae3a8
diff --git a/tests/qemu-iotests/group b/tests/qemu-iotests/group
9ae3a8
index 3b1d042..1017a19 100644
9ae3a8
--- a/tests/qemu-iotests/group
9ae3a8
+++ b/tests/qemu-iotests/group
9ae3a8
@@ -61,3 +61,4 @@
9ae3a8
 052 rw auto backing
9ae3a8
 053 rw auto
9ae3a8
 059 rw auto
9ae3a8
+068 rw auto
9ae3a8
-- 
9ae3a8
1.7.1
9ae3a8